%define anolis_release 1

%global soversion_major 1
%global soversion 1.0.41
%global _hardened_build 1

Summary: Libcgroup is a library that abstracts the control group file system in Linux
Name: libcgroup
Version: 3.1.0
Release: %{anolis_release}%{?dist}
License: LGPL-2.1-or-later
URL: https://libcg.sourceforge.net/
Source: https://github.com/%{name}/%{name}/archive/v%{version}/%{name}-%{version}.tar.gz
Provides: libcgroup-pam = %{version}-%{release}
Provides: libcgroup-tools < %{version}-%{release}
Obsoletes: libcgroup-pam = %{version}-%{release}
Obsoletes: libcgroup-tools < %{version}-%{release}

Patch0: config.patch
Patch1: Add-support-for-multiple-controllers-on-same-mount-point.patch

BuildRequires: autoconf, automake, libtool
BuildRequires: gcc,gcc-c++,byacc
BuildRequires: systemd-units,pam-devel,flex,coreutils,systemd-devel

Requires: systemd >= 217-0.2
Requires(pre): shadow-utils

%description
Cgroups is a Linux kernel feature that limits, accounts for, and isolates
the resource usage (CPU, memory, disk I/O, network, etc.) of a collection of processes.
The library helps manipulte and administrate control groups.

%package devel
Summary: Devel helps applications to use cgroups
Requires: %{name} = %{version}-%{release}
%description devel
Devel provides API for creating,deleting and modifying cgroup nodes.It allows
the creation of cgroups' configuration and provides scripts for managing it.

#%%package_help

%prep
%autosetup -p1 -n %{name}-%{version}

%build
autoreconf -vif
%configure --enable-pam-module-dir=%{_libdir}/security --enable-opaque-hierarchy="name=systemd" --disable-daemon --disable-static
%make_build

%install
%make_install
#%%delete_la

# config
install -d ${RPM_BUILD_ROOT}%{_sysconfdir}
install -d ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig
install -m 644 samples/config/cgsnapshot_denylist.conf $RPM_BUILD_ROOT%{_sysconfdir}/cgsnapshot_denylist.conf

# Only one pam_cgroup.so is needed
#mv -f $RPM_BUILD_ROOT%{_libdir}/security/pam_cgroup.so $RPM_BUILD_ROOT%{_libdir}/security/pam_cgroup.so
rm -f $RPM_BUILD_ROOT%{_libdir}/security/pam_cgroup.so.*

rm -f $RPM_BUILD_ROOT%{_libdir}/libcgroupfortesting.*

rm -f $RPM_BUILD_ROOT%{_mandir}/man5/cgred.conf.5*
rm -f $RPM_BUILD_ROOT%{_mandir}/man5/cgrules.conf.5*
rm -f $RPM_BUILD_ROOT%{_mandir}/man8/cgrulesengd.8*

%pre
getent group cgred >/dev/null || groupadd -r cgred

%files
%license COPYING
%{_libdir}/libcgroup.so.*
%config(noreplace) %{_sysconfdir}/cgsnapshot_denylist.conf
%{_bindir}/cgget
%{_bindir}/cgset
%{_bindir}/cgcreate
%{_bindir}/cgdelete
%{_bindir}/cgsnapshot
%{_bindir}/lscgroup
%{_bindir}/lssubsys
%{_sbindir}/cgconfigparser
%attr(2755, root, cgred) %{_bindir}/cgexec
%attr(2755, root, cgred) %{_bindir}/cgclassify
%attr(0755, root, root) %{_libdir}/security/pam_cgroup.so
%{_bindir}/cgxget
%{_bindir}/cgxset
%{_bindir}/libcgroup_systemd_idle_thread

%files devel
%license COPYING
%{_libdir}/libcgroup.so
%{_libdir}/pkgconfig/libcgroup.pc
%{_includedir}/libcgroup.h
%{_includedir}/libcgroup/*.h

#%%files help
%doc README README_systemd
%attr(0644, root, root) %{_mandir}/man1/*
%attr(0644, root, root) %{_mandir}/man5/*
%attr(0644, root, root) %{_mandir}/man8/*

%changelog
* Tue Nov 26 2024 lipengyu <lipengyu@kylinos.cn> - 3.1.0-6
- Type:update
- Id:NA
- SUG:NA
- DESC:Add support for multiple controller mount to same point

* Fri Oct 11 2024 Funda Wang <fundawang@yeah.net> - 3.1.0-5
- apply patch

* Fri Jul 12 2024 liuxu <liuxu156@huawei.com> - 3.1.0-4
- Type: bugfix
- Id:NA
- SUG:NA
- DESC:fix config.patch

* Fri Apr 12 2024 liuxu <liuxu156@huawei.com> - 3.1.0-3
- Type: bugfix
- Id:NA
- SUG:NA
- DESC:fix corrupted libcgroup-3.1.0.tar.gz

* Mon Aug 28 2023 luoyujie <luoyujie5@huawei.com> - 3.1.0-2
- Type: enhancement
- Id:NA
- SUG:NA
- DESC:delete unnecessary cgconfig service support

* Wed Aug 16 2023 luoyujie <luoyujie5@huawei.com> - 3.1.0-1
- Type: upgrade
- Id:NA
- SUG:NA
- DESC:update release version to v3.1.0

* Wed Apr 19 2023 jichengke <jichengke2011@gmail.com> - 2.0.3-2
- modify bogus date in changelog

* Thu Feb 9 2023 hanchao <hanchao47@huawei.com> - 2.0.3-1
- Type: upgrade
- Id:NA
- SUG:NA
- DESC:update release version to v2.0.3

* Thu Nov 3 2022 wuzx<wuzx1226@qq.com> - 0.42.2-3
- Type:feature
- CVE:NA
- SUG:NA
- DESC:Add sw64 architecture

* Thu May 5 2022 wangfengtu<wangfengtu@huawei.com> - 0.42.2-2
- Type: upgrade
- Id:NA
- SUG:NA
- DESC:update release version

* Wed Nov 4 2020 leizhongkai<leizhongkai@huawei.com> - 0.42.2-1
- Type: upgrade
- Id:NA
- SUG:NA
- DESC:new upstream release 0.42.2

* Tue Jan 7 2020 openEuler Buildteam <buildteam@openeuler.org> - 0.41-23
- Type:enhancement
- Id:NA
- SUG:NA
- DESC:modify spec patch

* Thu Dec 19 2019 openEuler Buildteam <buildteam@openeuler.org> - 0.41-22
- Type:enhancement
- Id:NA
- SUG:NA
- DESC:modify the config patch

* Thu Nov 7 2019 openEuler Buildteam <buildteam@openeuler.org> - 0.41-21
- Type:enhancement
- Id:NA
- SUG:NA
- DESC:modify the release

* Tue Jan 22 2019 lunankun<lunankun@huawei.com> - 0.41-20.h1
- Type:bugfix
- ID:NA
- SUG:restart
- DESC:change parser match order fix cgconfig error.

